CREATE SEQUENCE seq_article_id INCREMENT BY 1;
CREATE SEQUENCE seq_group_id INCREMENT BY 1;

CREATE TABLE articles (
    id integer GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    message_id varchar(255) NOT NULL,
    date timestamp NOT NULL,
    header longvarchar NOT NULL,
    body longvarchar NOT NULL,
    header_line varchar(255) NOT NULL,
    body_type varchar(10) DEFAULT 'text' NOT NULL
);

CREATE TABLE headers (
    article_id integer NOT NULL,
    name varchar(255) NOT NULL,
    value varchar(255) NOT NULL
);

CREATE TABLE groups (
    id integer GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
    name varchar(255) NOT NULL,
    creation_date timestamp NOT NULL,
    first_article integer,
    last_article integer,
    last_article_date timestamp
);

CREATE TABLE article_groups (
    article_id integer NOT NULL,
    group_id integer NOT NULL
);

ALTER TABLE articles
    ADD CONSTRAINT articles_message_id UNIQUE (message_id);
ALTER TABLE groups
    ADD CONSTRAINT group_name UNIQUE (name);
ALTER TABLE article_groups
    ADD CONSTRAINT article_groups_id UNIQUE (article_id,group_id);
ALTER TABLE headers
    ADD CONSTRAINT headers_id UNIQUE (article_id,name);

CREATE INDEX articles_date ON articles(date);
CREATE INDEX groups_creation_date ON groups(creation_date);

ALTER TABLE article_groups
    ADD CONSTRAINT ag_article_id FOREIGN KEY (article_id) REFERENCES articles(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE article_groups
    ADD CONSTRAINT ag_group_id FOREIGN KEY (group_id) REFERENCES groups(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE headers
    ADD CONSTRAINT headers_article_id FOREIGN KEY (article_id) REFERENCES articles(id) ON UPDATE CASCADE ON DELETE CASCADE;
