--
-- PostgreSQL database dump
--

SET client_encoding = 'UNICODE';
SET check_function_bodies = false;
SET client_min_messages = warning;

CREATE TABLE article_groups (
    article_id integer NOT NULL,
    group_id integer NOT NULL
);

CREATE TABLE articles (
    id integer DEFAULT nextval('seq_article_id'::text) NOT NULL,
    message_id character varying(255) NOT NULL,
    date timestamp with time zone NOT NULL,
    header text NOT NULL,
    body text NOT NULL,
    header_line character varying(255) NOT NULL,
    body_type character varying(10) DEFAULT 'text'::character varying NOT NULL
);

CREATE TABLE groups (
    id integer DEFAULT nextval('seq_group_id'::text) NOT NULL,
    name character varying(255) NOT NULL,
    creation_date timestamp with time zone NOT NULL,
    first_article integer,
    last_article integer,
    last_article_date timestamp with time zone
);

CREATE SEQUENCE seq_article_id
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

CREATE SEQUENCE seq_group_id
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE ONLY articles
    ADD CONSTRAINT articles_id PRIMARY KEY (id);
ALTER TABLE ONLY articles
    ADD CONSTRAINT articles_message_id UNIQUE (message_id);
ALTER TABLE ONLY groups
    ADD CONSTRAINT group_name UNIQUE (name);
ALTER TABLE ONLY groups
    ADD CONSTRAINT groups_id PRIMARY KEY (id);

CREATE INDEX articles_date ON articles USING btree (date);
CREATE INDEX groups_creation_date ON groups USING btree (creation_date);

ALTER TABLE ONLY article_groups
    ADD CONSTRAINT ag_article_id FOREIGN KEY (article_id) REFERENCES articles(id) ON UPDATE CASCADE ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;
ALTER TABLE ONLY article_groups
    ADD CONSTRAINT ag_group_id FOREIGN KEY (group_id) REFERENCES groups(id) ON UPDATE CASCADE ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED;