package tnntpd;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class Header {

  private int articleId ;
  private String name ;
  private String value ;
  
  public static Header loadFromStatement ( PreparedStatement stmt ) {
    try {
      ResultSet rs = stmt.executeQuery() ;
      rs.next() ;
      return loadFromResultSet(rs) ;    
    } catch ( SQLException e ) {
      return null ;
    }
  }
  
  public static Header loadFromResultSet ( ResultSet rs ) throws SQLException {
    Header h = new Header () ;
    h.setArticleId ( rs.getInt("article_id") ) ;
    h.setName ( rs.getString("name") ) ;
    h.setValue ( rs.getString("value") ) ;
    return h ;
  }

  public static OrderPreservingMap loadAllFromStatement (PreparedStatement stmt) {
    try {
      ResultSet rs = stmt.executeQuery() ;
      OrderPreservingMap map = new OrderPreservingMap () ;
      while ( rs.next() ) {
        Header h = Header.loadFromResultSet(rs) ;
        if ( h != null ) map.append(h.getName(),h.getValue()) ;
      }
      return map ;
    } catch ( SQLException e ) {
      return null ;
    }
  }

  public void update () throws SQLException {
    PreparedStatement stmt = NNTPConnection.getDB().prepareStatement("UPDATE headers SET value = ? WHERE article_id = ? AND name= ?;") ;
    stmt.setString(1,getValue());
    stmt.setInt(2,getArticleId()) ;
    stmt.setString(3,getName()) ;
    stmt.executeUpdate();
  }

  public void create () throws SQLException {
    PreparedStatement stmt = NNTPConnection.getDB().prepareStatement("INSERT INTO headers (article_id,name,value) VALUES (?, ?, ?);") ;
    stmt.setInt(1,getArticleId()) ;
    stmt.setString(2,getName()) ;
    stmt.setString(3,getValue()) ;
    stmt.execute() ;
  }
  
  
  /* **************************************************************************
   *                         Getters and Setters
   ****************************************************************************/
  
  public int getArticleId () {
    return articleId ;
  }
  public void setArticleId ( int articleId ) {
    this.articleId = articleId ;
  }
  public String getName () {
    return name ;
  }
  public void setName ( String name ) {
    this.name = name ;
  }
  public String getValue () {
    return value ;
  }
  public void setValue ( String value ) {
    this.value = value ;
  }
  
  
  
}
