/*
 * Created on May 26, 2005
 */
package tnntpd ;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

/**
 * @author lemming
 */
public class Settings {

  public static final String     FILE                  = "tnntpd.conf" ;
  public static final Properties defaultConfig                = new Properties () ;
  static {
    defaultConfig.setProperty ( "tnntpd.sql.driver", "org.hsqldb.jdbcDriver" ) ;
    defaultConfig.setProperty ( "tnntpd.sql.database", "jdbc:hsqldb:file:hsqldb/db1" ) ;
    defaultConfig.setProperty ( "tnntpd.sql.user", "sa" ) ;
    defaultConfig.setProperty ( "tnntpd.sql.passwd", "" ) ;
    defaultConfig.setProperty ( "tnntpd.articledir", "articles" ) ;
    defaultConfig.setProperty ( "tnntpd.tryinitdb", "true" ) ;
    defaultConfig.setProperty ( "tnntpd.port", "119" ) ;
    defaultConfig.setProperty ( "tnntpd.hostname", "localhost" ) ;
    //defaultConfig.setProperty ( "tnntpd.debug", "true" ) ;
  }
  private Properties      settings                     = defaultConfig ;

  public Settings () throws FileNotFoundException, IOException {
    load () ;
  }

  public void load () throws FileNotFoundException, IOException {
    settings.load ( new FileInputStream ( FILE ) ) ;
  }

  public void save () throws FileNotFoundException, IOException {
    settings.store ( new FileOutputStream ( FILE ), "TNNTPD Config File" ) ;
  }

  public Properties getProperties () {
    return settings ;
  }

  public String getProperty ( String key ) {
    return settings.getProperty ( key ) ;
  }

  public void setProperty ( String key, Object value ) {
    settings.setProperty ( key, value.toString () ) ;
  }

}