package tnntpd.command;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.util.LinkedList;

import tnntpd.Article;
import tnntpd.Group;
import tnntpd.NNTPConnection;

public class Command { 
  
  protected static String NEWLINE = NNTPConnection.NEWLINE ;
  
  protected static Connection getDB () {
    return NNTPConnection.getDB() ;
  }
  
  protected static LinkedList<String> readText () throws IOException {
    return NNTPConnection.getInstance().readText() ;
  }

  protected static String readTextLine () throws IOException {
    return NNTPConnection.getInstance().readTextLine() ;
  }

  protected static void printStatus ( int status, String text ) throws IOException {
    NNTPConnection.getInstance().printStatus(status,text) ;
  }
  
  protected static void printTextLine ( CharSequence text ) throws IOException {
    NNTPConnection.getInstance().printTextLine(text) ;
  }

  protected static void printText ( CharSequence text ) throws IOException {
    NNTPConnection.getInstance().printText(text) ;
  }
  
  protected static void printText ( BufferedReader text ) throws IOException {
    NNTPConnection.getInstance().printText(text) ;
  }

  protected static void printTextPart ( String text ) throws IOException {
    NNTPConnection.getInstance().printTextPart(text) ;
  }

  protected static void println ( CharSequence text ) throws IOException {
    NNTPConnection.getInstance().println(text) ;
  }

  protected static void flush () throws IOException {
    NNTPConnection.getInstance().flush() ;
  }
  
  protected static Article getCurrentArticle () {
    return NNTPConnection.getInstance().getCurrentArticle() ;
  }
  
  protected static Group getCurrentGroup () {
    return NNTPConnection.getInstance().getCurrentGroup() ;
  }

  protected static void setCurrentArticle ( Article current ) {
    NNTPConnection.getInstance().setCurrentArticle(current) ;
  }
  
  protected static void setCurrentGroup ( Group current ) {
    NNTPConnection.getInstance().setCurrentGroup(current) ;
  }

  protected static File getArticleDir () {
    return NNTPConnection.getInstance().getArticleDir() ;
  }
   
}
