package tnntpd.command;

import java.io.IOException;
import java.util.LinkedList;

import tnntpd.Group;

public class ListCommand extends Command {

  public static boolean process ( String[] command ) throws IOException {
    if ( ! command[0].equalsIgnoreCase("LIST") ) return false ;
    // untested, RFC977 complient
    if ( command.length >= 2 ) {
      if ( command[1].equalsIgnoreCase("OVERVIEW.FMT") ) {
        printStatus (215, "information follows" ) ;
        printText ( "Subject:\nFrom:\nDate:\nMessage-ID:\nReferences:\nBytes:\nLines:" ) ;
        return true;
      }
      if ( command[1].equalsIgnoreCase("NEWSGROUPS") ) {
        printStatus (215, "information follows" ) ;
        LinkedList<Group> list = Group.getAll() ;
        for ( Group g : list ) {
          printTextLine ( g.getName() + "\t" + "-" ) ;
        }
        println(".");
        flush() ;
        return true;
      }
      if ( command[1].equalsIgnoreCase("SUBSCRIPTIONS") ) {
        printStatus (215, "information follows" ) ;
        println(".");
        flush() ;
        return true;
      }
      if ( command[1].equalsIgnoreCase("EXTENSIONS") ) {
        printStatus (202, "Supported NNTP extensions." ) ;
        printTextLine ("LISTGROUP");
        println(".");
        flush() ;
        return true;
      }
      return false;
    }
    printStatus (215, "list of newsgroups follows" ) ;
    for ( Group g: Group.getAll() ) {
      printTextLine ( g.getName() + " " + g.getLastArticle() + " " + g.getFirstArticle() + " y" ) ;
    }
    println (".");
    flush() ;    
    return true;
  }
  
}
