package tnntpd.command;

import java.io.IOException;
import java.util.LinkedList;
import tnntpd.Article;
import tnntpd.Group;

public class ListGroupCommand extends Command {

  public static boolean process ( String[] command ) throws IOException {
    String commandName = command[0] ;
    if ( ! commandName.equalsIgnoreCase("LISTGROUP") ) return false ;
    // untested, RFC977 complient
    Group group = null ;
    if ( command.length >= 2 ) {
      group = Group.getByName(command[1]) ;
    } else {
      group = getCurrentGroup () ;
    }
    if ( group == null ) {
      printStatus ( 412, "Not currently in newsgroup") ;
      return true;
    }
    LinkedList<Article> list = group.getAllArticles() ;
    printStatus ( 211, "list of article numbers follow") ; // argh, bad english in RFC
    for ( Article a : list ) {
      printTextLine ( "" + a.getId() ) ;
    }
    println (".") ;
    flush() ;    
    return true ;
  }
  
}
