package tnntpd.command;

import java.io.IOException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.LinkedList;

import tnntpd.Group;

public class NewGroupsCommand extends Command {

  public static boolean process ( String[] command ) throws IOException {
    String commandName = command[0] ;
    if ( ! commandName.equalsIgnoreCase("NEWGROUPS") ) return false ;
    if ( command.length != 3 ) return false ;
    // untested, not RFC977 complient
    try {
      Timestamp date = new Timestamp ( new SimpleDateFormat ("yyMMdd HHmmss").parse(command[1] + " " + command[2] ).getTime()) ;
      printStatus (231, "list of new newsgroups follows") ;
      LinkedList<Group> list = Group.getAll(date) ;
      for ( Group g: list) {
        printTextLine ( g.getName() + " " + g.getLastArticle() + " " + g.getFirstArticle() + " y" ) ;
      }
      println(".");
      flush();
      return true ;
    } catch ( ParseException e ) {
      printStatus ( 511, "listing failed - invalid date format" ) ;
      return true;
    }
  }
  
}
