package tnntpd.command;

import java.io.IOException;

import tnntpd.Article;
import tnntpd.Group;

public class NextCommand extends Command {

  public static boolean process ( String[] command ) throws IOException {
    String commandName = command[0] ;
    if ( ! ( commandName.equalsIgnoreCase("NEXT") || commandName.equalsIgnoreCase("LAST") ) ) return false ;
    // untested, RFC977 complient
    Article currA = getCurrentArticle() ;
    Group currG = getCurrentGroup() ;
    if ( currA == null ) {
      printStatus ( 420, "no current article has been selected") ;
      return true;
    }
    if ( currG == null ) {
      printStatus ( 412, "no newsgroup selected") ;
      return true;
    }
    Article article ;
    if ( commandName.equalsIgnoreCase("NEXT") ) {
      article = currA.nextArticleInGroup(currG) ;
      if ( article == null ) {
        printStatus ( 421, "no next article in this group") ;
        return true;
      }
    } else {
      article = currA.prevArticleInGroup(currG) ;
      if ( article == null ) {
        printStatus ( 422, "no previous article in this group") ;
        return true;
      }
    }
    setCurrentArticle ( article ) ;
    printStatus ( 223, article.getId() + " " + article.getMessageId() + " article retrieved - request text separately" ) ;
    return true ;
  }
  
}
