package tnntpd.command;

import java.io.IOException;
import java.sql.SQLException;
import java.util.LinkedList;

import tnntpd.Article;
import tnntpd.OrderPreservingMap;

public class XoverCommand extends Command {

  public static boolean process ( String[] command ) throws IOException {
    if ( ! command[0].equalsIgnoreCase("XOVER") ) return false ;
    String range = command.length >= 2 ? command[1] : "" ;
    int first = 0 ;
    int last = 0 ;
    if ( getCurrentGroup() == null ) {
      printStatus ( 412, "No news group current selected") ; // argh, bad english in the RFC
      return true;
    }
    try {
      if ( range.equals("") ) {
        // empty range
        first = getCurrentArticle().getId() ;
        last = getCurrentArticle().getId() ;
      } else if ( range.endsWith("-") ) {
        // a-
        first = Integer.parseInt(range.substring(-1)) ;
        last = getCurrentGroup().getLastArticle() ;
      } else if ( range.contains("-") ) {
        // a-b
        first = Integer.parseInt(range.substring(0,range.indexOf("-"))) ;
        last = Integer.parseInt(range.substring(range.indexOf("-")+1)) ;
      } else {
        // a
        first = Integer.parseInt(range) ;
        last = Integer.parseInt(range) ;        
      }
    } catch ( NumberFormatException e ) {}
    catch ( NullPointerException e ) {} // will cause a 420
    LinkedList<Article> list = getCurrentGroup().getAllArticles(first,last) ;
    if ( list.isEmpty() ) {
      printStatus ( 420, "No article(s) selected") ;
      return true;
    }
    printStatus ( 224, "Overview information follows") ;
      for ( Article a : list ) {
        try {
          OrderPreservingMap h = a.getHeaders() ;
          printTextLine ( a.getId() + "\t" + h.get("SUBJECT") + "\t" + h.get("FROM") + "\t" + h.get("DATE") + "\t" + a.getMessageId() + "\t" + h.get("REFERENCES") + "\t" + h.get("BYTES") + "\t" + h.get("LINES") ) ;
        } catch ( SQLException e ) {
          e.printStackTrace() ;
        }
      }
    println (".") ;
    flush() ;    
    return true;
  }
  
}
